// This file is generated by kconfig_compiler from kcalc.kcfg.
// All changes you do to this file will be lost.
#ifndef KCALCSETTINGS_H
#define KCALCSETTINGS_H

#include <kconfigskeleton.h>

class KCalcSettings : public KConfigSkeleton
{
  public:

    static KCalcSettings *self();
    ~KCalcSettings();

    /**
      Get The foreground color of the display.
    */
    static
    QColor foreColor()
    {
      return self()->mForeColor;
    }

    /**
      Get The background color of the display.
    */
    static
    QColor backColor()
    {
      return self()->mBackColor;
    }

    /**
      Get The color of number buttons.
    */
    static
    QColor numberButtonsColor()
    {
      return self()->mNumberButtonsColor;
    }

    /**
      Get The color of function buttons.
    */
    static
    QColor functionButtonsColor()
    {
      return self()->mFunctionButtonsColor;
    }

    /**
      Get The color of statistical buttons.
    */
    static
    QColor statButtonsColor()
    {
      return self()->mStatButtonsColor;
    }

    /**
      Get The color of hex buttons.
    */
    static
    QColor hexButtonsColor()
    {
      return self()->mHexButtonsColor;
    }

    /**
      Get The color of memory buttons.
    */
    static
    QColor memoryButtonsColor()
    {
      return self()->mMemoryButtonsColor;
    }

    /**
      Get The color of operation buttons.
    */
    static
    QColor operationButtonsColor()
    {
      return self()->mOperationButtonsColor;
    }

    /**
      Get The font to use in the display.
    */
    static
    QFont font()
    {
      return self()->mFont;
    }

    /**
      Get Maximum number of digits.
    */
    static
    int precision()
    {
      return self()->mPrecision;
    }

    /**
      Get Number of fixed decimal places.
    */
    static
    int fixedPrecision()
    {
      return self()->mFixedPrecision;
    }

    /**
      Get Whether to use fixed decimal places.
    */
    static
    bool fixed()
    {
      return self()->mFixed;
    }

    /**
      Get Whether to beep on error.
    */
    static
    bool beep()
    {
      return self()->mBeep;
    }

    /**
      Get Whether to show the result in the window title.
    */
    static
    bool captionResult()
    {
      return self()->mCaptionResult;
    }

    /**
      Set Whether to show statistical buttons.
    */
    static
    void setShowStat( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowStat" ) ))
        self()->mShowStat = v;
    }

    /**
      Get Whether to show statistical buttons.
    */
    static
    bool showStat()
    {
      return self()->mShowStat;
    }

    /**
      Set Whether to show Exp/Log buttons.
    */
    static
    void setShowExpLog( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowExpLog" ) ))
        self()->mShowExpLog = v;
    }

    /**
      Get Whether to show Exp/Log buttons.
    */
    static
    bool showExpLog()
    {
      return self()->mShowExpLog;
    }

    /**
      Set Whether to show trigonometric buttons.
    */
    static
    void setShowTrig( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowTrig" ) ))
        self()->mShowTrig = v;
    }

    /**
      Get Whether to show trigonometric buttons.
    */
    static
    bool showTrig()
    {
      return self()->mShowTrig;
    }

    /**
      Set Whether to show logic buttons.
    */
    static
    void setShowLogic( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowLogic" ) ))
        self()->mShowLogic = v;
    }

    /**
      Get Whether to show logic buttons.
    */
    static
    bool showLogic()
    {
      return self()->mShowLogic;
    }

    /**
      Set Whether to show constant buttons.
    */
    static
    void setShowConstants( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "ShowConstants" ) ))
        self()->mShowConstants = v;
    }

    /**
      Get Whether to show constant buttons.
    */
    static
    bool showConstants()
    {
      return self()->mShowConstants;
    }

    /**
      Get Name of constant C1
    */
    static
    QString nameConstant1()
    {
      return self()->mNameConstant1;
    }

    /**
      Get Name of constant C2
    */
    static
    QString nameConstant2()
    {
      return self()->mNameConstant2;
    }

    /**
      Get Name of constant C3
    */
    static
    QString nameConstant3()
    {
      return self()->mNameConstant3;
    }

    /**
      Get Name of constant C4
    */
    static
    QString nameConstant4()
    {
      return self()->mNameConstant4;
    }

    /**
      Get Name of constant C5
    */
    static
    QString nameConstant5()
    {
      return self()->mNameConstant5;
    }

    /**
      Get Name of constant C6
    */
    static
    QString nameConstant6()
    {
      return self()->mNameConstant6;
    }

    /**
      Get Value of constant C1
    */
    static
    QString valueConstant1()
    {
      return self()->mValueConstant1;
    }

    /**
      Get Value of constant C2
    */
    static
    QString valueConstant2()
    {
      return self()->mValueConstant2;
    }

    /**
      Get Value of constant C3
    */
    static
    QString valueConstant3()
    {
      return self()->mValueConstant3;
    }

    /**
      Get Value of constant C4
    */
    static
    QString valueConstant4()
    {
      return self()->mValueConstant4;
    }

    /**
      Get Value of constant C5
    */
    static
    QString valueConstant5()
    {
      return self()->mValueConstant5;
    }

    /**
      Get Value of constant C6
    */
    static
    QString valueConstant6()
    {
      return self()->mValueConstant6;
    }

    static
    void writeConfig()
    {
      static_cast<KConfigSkeleton*>(self())->writeConfig();
    }
  protected:
    KCalcSettings();
    static KCalcSettings *mSelf;


    // Colors
    QColor mForeColor;
    QColor mBackColor;
    QColor mNumberButtonsColor;
    QColor mFunctionButtonsColor;
    QColor mStatButtonsColor;
    QColor mHexButtonsColor;
    QColor mMemoryButtonsColor;
    QColor mOperationButtonsColor;

    // Font
    QFont mFont;

    // Precision
    int mPrecision;
    int mFixedPrecision;
    bool mFixed;

    // General
    bool mBeep;
    bool mCaptionResult;
    bool mShowStat;
    bool mShowExpLog;
    bool mShowTrig;
    bool mShowLogic;
    bool mShowConstants;

    // Constants
    QString mNameConstant1;
    QString mNameConstant2;
    QString mNameConstant3;
    QString mNameConstant4;
    QString mNameConstant5;
    QString mNameConstant6;
    QString mValueConstant1;
    QString mValueConstant2;
    QString mValueConstant3;
    QString mValueConstant4;
    QString mValueConstant5;
    QString mValueConstant6;

  private:
};

#endif
